﻿using SqlSugar;
using System.ComponentModel;
using XF.Domain.Repository;

namespace DataSharing.Police110.DCJT110
{
    /// <summary>
    /// 大成均图受理工单表
    /// </summary>
    [Description("大成均图受理工单表-发送")]
    public class DsPoliceSendChainAlarmDcjt : CreationModificationEntity
    {
        /// <summary>
        /// 流水号   
        /// </summary>
        [SugarColumn(ColumnDescription = "接警单编号", ColumnDataType = "varchar(50)")]
        public string SerialNumber { get; set; }

        /// <summary>
        /// 接警员编号
        /// </summary>
        [SugarColumn(ColumnDescription = "接警员编号", ColumnDataType = "varchar(30)")]
        public string RegisterNo { get; set; }

        /// <summary>
        /// 接警员姓名
        /// </summary>
        [SugarColumn(ColumnDescription = "接警员姓名", ColumnDataType = "varchar(30)")]
        public string RegisterName { get; set; }

        /// <summary>
        /// 接警单编号
        /// </summary>
        [SugarColumn(ColumnDescription = "接警单编号", ColumnDataType = "varchar(50)")]
        public string AlarmReceiptNumber { get; set; }

        /// <summary>
        /// 报警电话
        /// </summary>
        [SugarColumn(ColumnDescription = "报警电话", ColumnDataType = "varchar(20)")]
        public string CallPoliceNumber { get; set; }

        /// <summary>
        /// 报警人性别
        /// </summary>
        [SugarColumn(ColumnDescription = "报警人性别", ColumnDataType = "varchar(10)")]
        public string FromGender { get; set; }

        /// <summary>
        /// 报警电话用户名
        /// </summary>
        [SugarColumn(ColumnDescription = "报警电话用户名", ColumnDataType = "varchar(20)")]
        public string CallPoliceName { get; set; }

        /// <summary>
        /// 联系电话
        /// </summary>
        [SugarColumn(ColumnDescription = "联系电话", ColumnDataType = "varchar(20)")]
        public string PhoneNumber { get; set; }

        /// <summary>
        /// 报警地址
        /// </summary>
        [SugarColumn(ColumnDescription = "报警地址", ColumnDataType = "varchar(200)")]
        public string CallPoliceAddress { get; set; }

        /// <summary>
        /// 警情类别代码
        /// </summary>
        [SugarColumn(ColumnDescription = "警情类别代码", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string PoliceTypeCode { get; set; }

        /// <summary>
        /// 警情类别名称
        /// </summary>
        [SugarColumn(ColumnDescription = "警情类别名称", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string PoliceTypeName { get; set; }

        /// <summary>
        /// 报警内容
        /// </summary>
        [SugarColumn(ColumnDescription = "报警内容", ColumnDataType = "varchar(2000)")]
        public string CallPoliceContent { get; set; }

        /// <summary>
        /// 管辖单位代码
        /// </summary>
        [SugarColumn(ColumnDescription = "管辖单位代码", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string JurisdictionalUnitCode { get; set; }

        /// <summary>
        /// 管辖单位名称
        /// </summary>
        [SugarColumn(ColumnDescription = "管辖单位名称", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string JurisdictionalUnitName { get; set; }

        /// <summary>
        /// 管辖单位电话
        /// </summary>
        [SugarColumn(ColumnDescription = "管辖单位电话", ColumnDataType = "varchar(20)", IsNullable = true)]
        public string JurisdictionalUnitNumber { get; set; }

        /// <summary>
        /// 报警时间
        /// </summary>
        [SugarColumn(ColumnDescription = "报警时间")]
        public DateTime? CallPoliceTime { get; set; }

        /// <summary>
        /// 推送时间
        /// </summary>
        [SugarColumn(ColumnDescription = "推送时间")]
        public DateTime? PushTime { get; set; }

        /// <summary>
        /// 接警单位代码
        /// </summary>
        [SugarColumn(ColumnDescription = "接警单位代码", ColumnDataType = "varchar(50)")]
        public string AlarmReceivingUnitCode { get; set; }

        /// <summary>
        /// 接警单位名称
        /// </summary>
        [SugarColumn(ColumnDescription = "接警单位名称", ColumnDataType = "varchar(50)")]
        public string AlarmReceivingUnitName { get; set; }

        /// <summary>
        /// 接警类型
        /// </summary>
        [SugarColumn(ColumnDescription = "接警类型", ColumnDataType = "varchar(50)")]
        public string AlarmReceptionType { get; set; }

        /// <summary>
        /// 行政区划代码
        /// </summary>
        [SugarColumn(ColumnDescription = "行政区划代码", ColumnDataType = "varchar(50)")]
        public string AreaCode { get; set; }

        /// <summary>
        /// 工单编号
        /// </summary>
        [SugarColumn(ColumnDescription = "工单编号", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string OrderId { get; set; }
    }
}
