﻿using SqlSugar;
using System.ComponentModel;
using XF.Domain.Repository;

namespace DataSharing.Police110.DCJT110
{
    /// <summary>
    /// 大成均图办理结果表
    /// </summary>
    [Description("大成均图办理结果表-发送")]
    public class DsPoliceSendChainDealDcjt : CreationModificationEntity
    {
        /// <summary>
        /// 工单编号
        /// </summary>
        [SugarColumn(ColumnDescription = "工单编号", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string OrderId { get; set; }

        /// <summary>
        /// 接警单编号
        /// </summary>
        [SugarColumn(ColumnDescription = "接警单编号", ColumnDataType = "varchar(50)")]
        public string AlarmReceiptNumber { get; set; }

        /// <summary>
        /// 反馈时间
        /// </summary>
        [SugarColumn(ColumnDescription = "反馈时间", IsNullable = true)]
        public DateTime? FeedbackTime { get; set; }

        /// <summary>
        /// 出警处置情况
        /// </summary>
        [SugarColumn(ColumnDescription = "出警处置情况", ColumnDataType = "varchar(2000)", IsNullable = true)]
        public string DisposalSituation { get; set; }

        /// <summary>
        /// 警情处理结果说明
        /// </summary>
        /// </summary>
        [SugarColumn(ColumnDescription = "警情处理结果说明", ColumnDataType = "varchar(2000)", IsNullable = true)]
        public string ResultDescription { get; set; }

        /// <summary>
        /// 反馈人员编号
        /// </summary>
        [SugarColumn(ColumnDescription = "反馈人员编号", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string FeedbackPersonNumber { get; set; }

        /// <summary>
        /// 反馈人员姓名
        /// </summary>
        [SugarColumn(ColumnDescription = "反馈人员姓名", ColumnDataType = "varchar(30)", IsNullable = true)]
        public string FeedbackPersonName { get; set; }

        /// <summary>
        /// 反馈单位代码
        /// </summary>
        [SugarColumn(ColumnDescription = "反馈单位代码", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string FeedbackUnitCode { get; set; }

        /// <summary>
        /// 反馈单位名称
        /// </summary>
        [SugarColumn(ColumnDescription = "反馈单位名称", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string FeedbackUnitName { get; set; }

        /// <summary>
        /// 回访时间
        /// </summary>
        [SugarColumn(ColumnDescription = "回访时间", IsNullable = true)]
        public DateTime? RevisitTime { get; set; }

        /// <summary>
        /// 电话回访核实情况
        /// </summary>
        [SugarColumn(ColumnDescription = "电话回访核实情况", ColumnDataType = "varchar(2000)", IsNullable = true)]
        public string CheckingContent { get; set; }

        /// <summary>
        /// 回访结果
        /// </summary>
        [SugarColumn(ColumnDescription = "回访结果", ColumnDataType = "varchar(20)", IsNullable = true)]
        public string VisitResult { get; set; }

        /// <summary>
        /// 回访内容
        /// </summary>
        [SugarColumn(ColumnDescription = "回访内容", ColumnDataType = "varchar(2000)", IsNullable = true)]
        public string VisitContent { get; set; }

        /// <summary>
        /// 退回接警员
        /// </summary>
        [SugarColumn(ColumnDescription = "退回接警员", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string ReturnName { get; set; }

        /// <summary>
        /// 退回部门
        /// </summary>
        [SugarColumn(ColumnDescription = "退回部门", ColumnDataType = "varchar(50)", IsNullable = true)]
        public string ReturnUnit { get; set; }

        /// <summary>
        /// 退回原因
        /// </summary>
        [SugarColumn(ColumnDescription = "退回原因", ColumnDataType = "varchar(2000)", IsNullable = true)]
        public string ReturnOpinion { get; set; }

        /// <summary>
        /// 退回时间
        /// </summary>
        [SugarColumn(ColumnDescription = "退回时间", IsNullable = true)]
        public DateTime? ReturnTime { get; set; }

        /// <summary>
        /// 处置类型 1正常 2退回 3回访 4警情签收状态 5是结果签收状态  
        /// </summary>
        [SugarColumn(ColumnDescription = "处置类型")]
        public string? DisposalType { get; set; }

        /// <summary>
        /// 入库时间
        /// </summary>
        [SugarColumn(ColumnDescription = "入库时间")]
        public DateTime? WarehousingTime { get; set; }
    }
}
