﻿using System.ComponentModel;
using DataSharing.Share.Enums;
using SqlSugar;
using XF.Domain.Repository;

namespace DataSharing.Police110.DaoShu110
{
    /// <summary>
    /// 110交换调用接口数据
    /// </summary>
    [Description("110交换调用接口数据")]
    public class DsReceivePoliceData : CreationModificationEntity
    {
        /// <summary>
        /// 外部工单编号，唯一标识  
        /// </summary>
        [SugarColumn(ColumnDescription = "外部工单编号，唯一标识", ColumnDataType = "varchar(50)")]
        public string? ExternalId { get; set; }

        /// <summary>
        /// 服务接口名称
        /// </summary>
        [SugarColumn(ColumnDescription = "服务接口名称", ColumnDataType = "varchar(100)")]
        public string? ServiceInterface { get; set; }

        /// <summary>
        /// 接收原始数据
        /// </summary>
        [SugarColumn(ColumnDescription = "接收原始数据", ColumnDataType = "text")]
        public string? ReceiveRawData { get; set; }

        /// <summary>
        /// 接收解密数据数据
        /// </summary>
        [SugarColumn(ColumnDescription = "接收解密数据数据", ColumnDataType = "text")]
        public string? ReceiveData { get; set; }

        /// <summary>
        /// 数据来源方
        /// </summary>
        [SugarColumn(ColumnDescription = "数据来源方")]
        public EPoliceSource? PoliceSource { get; set; }
    }
}
