﻿using DataSharing.Share.Enums;
using DataSharing.Share.Requests;

namespace DataSharing.Share.Dtos.HotlineWeb
{
    public record QuerySendTaskFixedDto :QuerySendTaskDto{
        /// <summary>
        /// 查询批次
        /// </summary>
        public int QueryIndex { get; set; }
    }


    public record QuerySendTaskDto : PagedKeywordRequest
    {
        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime? EndTime { get; set; }

        /// <summary>
        /// Id,空查全部
        /// </summary>
        public string? Id { get; set; }

        /// <summary>
        /// 是否推送成功
        /// </summary>
        public bool? IsSuccess { get; set; }

        /// <summary>
        /// 查询类型 1：服务工单受理，2、电话记录，3、服务工单处理过程，4、服务工单处理结果，5、省平台其他推送，6、其他平台
        /// </summary>
        public string SelectType { get; set; } = "1";

        /// <summary>
        /// 省工单编号
        /// </summary>
        public string? CaseSerial { get; set; }

        /// <summary>
        /// 请求地址
        /// </summary>
        public string? Path { get; set; }

        /// <summary>
        /// 业务平台
        /// </summary>
        public EPlatformSource? PlatformSource { get; set; }
    }

    public record QueryCaseMaterialInfoDto : PagedKeywordRequest
    {
        /// <summary>
        /// 开始时间
        /// </summary>
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// 结束时间
        /// </summary>
        public DateTime? EndTime { get; set; }

        /// <summary>
        /// 省工单编号
        /// </summary>
        public string? CaseSerial { get; set; }
    }
}
