﻿using DataSharing.Share.Dtos.CityStateDataExchange;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.Json.Serialization;
using System.Threading.Tasks;

namespace DataSharing.Share.Dtos.LuZhou
{
    public class WineCityDto
    {
        /// <summary>
        /// 密钥
        /// </summary>
        [MDisplayName("密钥")]
        [VRequired]
        public string AcceptSign { get; set; }

        /// <summary>
        /// 内容
        /// </summary>
        [MDisplayName("密钥")]
        [VRequired]
        public string AcceptContent { get; set; }
    }

    public class WineCityCodePwd
    {
        /// <summary>
        /// 受理编号
        /// </summary>
        [MDisplayName("受理编号")]
        [VRequired]
        public string AcceptCode { get; set; }

        /// <summary>
        /// 受理密码
        /// </summary>
        [MDisplayName("受理密码")]
        [VRequired]
        public string AcceptPwd { get; set; }
    }

    public class WineCity
    {
        /// <summary>
        /// 区域编码
        /// </summary>
        [MDisplayName("区域编码")]
        [VRequired]
        public string AeraID { get; set; }

        /// <summary>
        /// 受理编码
        /// </summary>
        [MDisplayName("受理编码")]
        [VRequired]
        public string PurTypeID { get; set; }

        /// <summary>
        /// 热点编码
        /// </summary>
        public string ConTypeID { get; set; }

        /// <summary>
        /// 受理标题
        /// </summary>
        [MDisplayName("受理标题")]
        [VRequired]
        public string Title { get; set; }

        /// <summary>
        /// 受理内容
        /// </summary>
        [MDisplayName("受理内容")]
        [VRequired]
        public string Content { get; set; }

        /// <summary>
        /// 联系人
        /// </summary>
        [MDisplayName("联系人")]
        [VRequired]
        public string LinkName { get; set; }

        /// <summary>
        /// 来电号码
        /// </summary>
        public string FromTel { get; set; }

        /// <summary>
        /// 联系电话
        /// </summary>
        [MDisplayName("联系电话")]
        [VRequired]
        public string LinkTel { get; set; }

        /// <summary>
        /// 性别
        /// </summary>
        public string LinkSex { get; set; }

        /// <summary>
        /// 地址
        /// </summary>
        public string Address { get; set; }

        /// <summary>
        /// 是否保密
        /// </summary>
        public string SFlag { get; set; }
    }



    public class WriteOrderResponseWineCityDto
    {
        /// <summary>
        /// 状态
        /// </summary>
        [JsonPropertyName("code")]
        public string Code { get; set; }

        /// <summary>
        /// 消息
        /// </summary>
        [JsonPropertyName("msg")]
        public object Msg { get; set; }

        public static WriteOrderResponseWineCityDto Success(string Code, WineCityCodePwdDto wccpd)
        {
            return new WriteOrderResponseWineCityDto
            {
                Code = "1",
                Msg = wccpd
            };
        }

        public static WriteOrderResponseWineCityDto Success(string Code, WinCityDetailDataDto wcddd)
        {
            return new WriteOrderResponseWineCityDto
            {
                Code = "1",
                Msg = wcddd
            };
        }

        /// <summary>
        /// 失败
        /// </summary>
        /// <param name="code"></param>
        /// <param name="description"></param>
        /// <returns></returns>
        public static WriteOrderResponseWineCityDto Failed(string? Code = "0", string? Msg = "")
        {
            return new WriteOrderResponseWineCityDto
            {
                Code = "0",
                Msg = Msg
            };
        }
    }

    public class WinCityDetailCodeDto
    {
        public string code { get; set; }
        public WinCityDetailListDto msg { get; set; }
    }

    public class WinCityDetailListDto
    {
        public List<WinCityDetailInfoDto> data { get; set; }
    }

    public class WinCityDetailDataDto
    {
        public WinCityDetailInfoDto data { get; set; }
    }

    public class WinCityDetailInfoDto
    {
        public string Code { get; set; }
        public string AddDate { get; set; }
        public string Content { get; set; }
        public string Result { get; set; }
    }

    public class WineCityCodePwdDto
    {
        /// <summary>
        /// 受理编号
        /// </summary>
        public string AcceptCode { get; set; }

        /// <summary>
        /// 受理密码
        /// </summary>
        public string AcceptPwd { get; set; }
    }
}
