﻿using DataSharing.Share.Dtos.Province.Extend;
using System.Text.Json.Serialization;

namespace DataSharing.Share.Dtos.Province.XieTong.Receive
{
    /// <summary>
    /// 
    /// </summary>
    public class ReceiveCaseExtendsRequest
    {
        /// <summary>
        /// 
        /// </summary>
        public ClientInfo token { get; set; }

        /// <summary>
        /// 数据
        /// </summary>
        public ReceiveCaseExtendsModel paras { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class ReceiveCaseExtendsModel
    {
        /// <summary>
        /// 服务工单编号 
        /// </summary>
        [JsonPropertyName("CASE_SERIAL")]
        [MDisplayName("服务工单编号")]
        [VRequired]
        [VStringLength(0, 50)]
        public string CaseSerial { get; set; }

        /// <summary>
        /// 表单类型
        /// </summary>
        [JsonPropertyName("FORM_TYPE")]
        [MDisplayName("表单类型")]
        [VRequired]
        [VStringLength(0, 50)]
        public string FormType { get; set; }

        /// <summary>
        /// 医疗工单
        /// </summary>
        [JsonPropertyName("FORM_MEDICAL")]
        public FormMedicalInfo? FormMedical { get; set; }

        /// <summary>
        /// 电视购物及商铺购买退换货工单
        /// </summary>
        [JsonPropertyName("FORM_RETURNEXCHANGE")]
        public FormReturnexChangeInfo? FormReturnexChange { get; set; }

        /// <summary>
        /// 电视台虚假广告工单
        /// </summary>
        [JsonPropertyName("FORM_SHAMPUB")]
        public FormShamPubInfo? FormShamPub { get; set; }

        /// <summary>
        /// 高速公路工单
        /// </summary>
        [JsonPropertyName("FORM_EXPRESSWAY")]
        public FormExpressWayInfo? FormExpressWay { get; set; }

        /// <summary>
        /// 四川政务服务网技术工单
        /// </summary>
        [JsonPropertyName("FORM_NETWORKTEC")]
        public FormNetWorktecInfo? FormNetWorktec { get; set; }

        /// <summary>
        /// 12366投诉表单
        /// </summary>
        [JsonPropertyName("FORM_TAXATION_COMPLAINT")]
        public FormTaxationComplaintInfo? FormTaxationComplaint { get; set; }

        /// <summary>
        /// 四川省12366热线咨询交办单
        /// </summary>
        [JsonPropertyName("FORM_TAXATION_CONSULTING")]
        public FormTaxationConsultingInfo? FormTaxationConsulting { get; set; }

        /// <summary>
        /// 12328服务监督中心受理单
        /// </summary>
        [JsonPropertyName("FORM_TRAFFIC")]
        public FormTrafficInfo? FormTraffic { get; set; }

        /// <summary>
        /// 邮政业消费者申诉受理信息
        /// </summary>
        [JsonPropertyName("FORM_POST")]
        public FormPostInfo? FormPost { get; set; }

        /// <summary>
        /// 环保举报业务专业表单
        /// </summary>
        [JsonPropertyName("FORM_ENVIRONMENT")]
        public FormEnvironMentInfo? FormEnvironMent { get; set; }

    }
}
