﻿namespace DataSharing.Share.Dtos.YiBin.ConvergenceMedia
{
    /// <summary>
    /// 工单列表
    /// </summary>
    public record GetOrderMediaReceiveDto
    {
        /// <summary>
        /// 接口密钥
        /// </summary>
        public string Code { get; set; }

        /// <summary>
        /// 工单编号
        /// </summary>
        public string AcceptCode { get; set; }

        /// <summary>
        /// 标题
        /// </summary>
        public string Title { get; set; }

        /// <summary>
        /// 手机号
        /// </summary>
        public string Mobile { get; set; }

        /// <summary>
        /// 受理类型编码
        /// </summary>
        public int? PurTypeID { get; set; }

        /// <summary>
        /// 工单办理状态Code  1：办理中，2：办理完成 ，其他查询全部
        /// </summary>
        public string? HandleStateCode { get; set; }

        /// <summary>
        /// 开始时间（格式：2020-01-01）
        /// </summary>
        public string StartDate { get; set; }

        /// <summary>
        /// 结束时间（格式：2020-01-01）
        /// </summary>
        public string EndDate { get; set; }

        /// <summary>
        /// 当前页
        /// </summary>
        public int CurrentPage { get; set; } = 1;

        /// <summary>
        /// 查询每页大小（每页最大20条）
        /// </summary>
        public int PageSize { get; set; } = 10;

    }
}
