﻿using System.Text.Json.Serialization;

namespace DataSharing.Share.Dtos.YiBin.WllzYB
{
    public class PortalStatisticsDto
    {
        /// <summary>
        /// 工单统计
        /// </summary>
        public List<DayStatisticsDto> Info { get; set; }

        /// <summary>
        /// 受理类型
        /// </summary>
        public List<KeyValueDto> Type { get; set; }

        /// <summary>
        /// 热点
        /// </summary>
        public List<KeyValueDto> From { get; set; }

        /// <summary>
        /// 其他
        /// </summary>
        public List<string> Overdue { get; set; }
    }

    public class DayStatisticsDto
    {
        /// <summary>
        /// 总量
        /// </summary>
        [JsonPropertyName("AllCount")]
        public int AllCount { get; set; }

        /// <summary>
        /// 总量已办
        /// </summary>
        [JsonPropertyName("AllTrandCount")]
        public int AllTrandCount { get; set; }

        /// <summary>
        /// 今日总量
        /// </summary>
        [JsonPropertyName("DayCount")]
        public int DayCount { get; set; }

        /// <summary>
        /// 今日已办
        /// </summary>
        [JsonPropertyName("DayTrandCount")]
        public int DayTrandCount { get; set; }
    }

    public class KeyValueDto
    {
        /// <summary>
        /// 
        /// </summary>
        public string Name { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public int Value { get; set; }

    }
}
