﻿namespace DataSharing.Share.Requests;

public record PagedKeywordRequest : PagedRequest
{
    public string? Keyword { get; set; }
}

public record ReportPagedRequest : PagedKeywordRequest 
{

	/// <summary>
	/// 开始时间
	/// </summary>
	public DateTime? StartTime { get; set; }

	/// <summary>
	/// 结束时间
	/// </summary>
	public DateTime? EndTime { get; set; }

	/// <summary>
	/// 排序字段 
	/// </summary>
	public string SortField { get; set; }

	/// <summary>
	/// 排序规则  0 升序  1 降序
	/// </summary>
	public int SortRule { get; set; }

}