﻿namespace DataSharing
{
    public class ChannelConfiguration
    {
        /// <summary>
        /// 服务名称
        /// </summary>
        public string ProcessingServices { get; set; }

        /// <summary>
        /// 是否开启推送
        /// </summary>
        public bool IsOpenPush { get; set; }

        /// <summary>
        /// 业务系统附件上传配置
        /// </summary>
        public ConfigurationBusinessFile BusinessFile { get; set; }

        /// <summary>
        /// 写入工单数据
        /// </summary>
        public ConfigurationHotlineClient HotlineClient { get; set; }

        /// <summary>
        /// 省12345
        /// </summary>
        public ConfigurationProvince Province { get; set; }

    }

    /// <summary>
    /// 省12345
    /// </summary>
    public class ConfigurationProvince
    {
        /// <summary>
        /// 汇聚业务地址
        /// </summary>
        public string HuiJu { get; set; } = string.Empty;

        /// <summary>
        /// 协同业务地址
        /// </summary>
        public string XieTong { get; set; } = string.Empty;

        /// <summary>
        /// 汇聚业务Id
        /// </summary>
        public string ClientId { get; set; } = string.Empty;

        /// <summary>
        /// 汇聚业务秘钥
        /// </summary>
        public string ClientSecret { get; set; } = string.Empty;

        /// <summary>
        /// 协同业务Id
        /// </summary>
        public string ClientIdXieTong { get; set; } = string.Empty;

        /// <summary>
        /// 协同业务秘钥
        /// </summary>
        public string ClientSecretXieTong { get; set; } = string.Empty;

        /// <summary>
        /// 
        /// </summary>
        public string Scheme { get; set; } = string.Empty;

        /// <summary>
        /// 未接通最大上传数量
        /// </summary>
        public int MissedCallCount { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public DateTime? SendTaskStartTime { get; set; }
    }

    /// <summary>
    /// 查询公开数据
    /// </summary>
    public class ConfigurationIYB
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string QueryOldList { get; set; } = string.Empty;
    }

    /// <summary>
    /// 企业服务
    /// </summary>
    public class ConfigurationEnterprise
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string AddressUrl { get; set; } = string.Empty;

        /// <summary>
        /// id
        /// </summary>
        public string ClientId { get; set; } = string.Empty;

        /// <summary>
        /// 密钥
        /// </summary>
        public string ClientSecret { get; set; } = string.Empty;

        /// <summary>
        /// 
        /// </summary>
        public string TenantId { get; set; } = string.Empty;

    }

    /// <summary>
    /// 市州数据交换
    /// </summary>
    public class ConfigurationCityHandOver
    {
        /// <summary>
        /// 信件接收接口地址
        /// </summary>
        public string PushOrder { get; set; } = string.Empty;

        /// <summary>
        /// 办理结果接收地址
        /// </summary>
        public string PushOpinion { get; set; } = string.Empty;

    }

    /// <summary>
    /// 系统市州编码
    /// </summary>
    public class ConfigurationCityCode
    {
        /// <summary>
        /// 
        /// </summary>
        public string AreaCode { get; set; } = string.Empty;

        public string AreaName { get; set; } = string.Empty;
    }

    /// <summary>
    /// 业务系统附件上传配置
    /// </summary>
    public class ConfigurationBusinessFile
    {
        /// <summary>
        /// 请求地址
        /// </summary>
        public string BaseUrl { get; set; }

        /// <summary>
        /// 上传接口地址
        /// </summary>
        public string UploadUrlAddress { get; set; }

        /// <summary>
        /// 下载接口
        /// </summary>
        public string DownloadUrlAddress { get; set; }

        /// <summary>
        /// 来源
        /// </summary>
        public string Source { get; set; }
    }

    /// <summary>
    /// 道枢110
    /// </summary>
    public class ConfigurationPoliceDS
    {
        /// <summary>
        /// 管辖单位代码
        /// </summary>
        public string GXDWDM { get; set; } = string.Empty;

        /// <summary>
        /// 管辖单位名称
        /// </summary>
        public string GXDWMC { get; set; } = string.Empty;

        /// <summary>
        /// 管辖单位电话
        /// </summary>
        public string GXDWDH { get; set; } = string.Empty;

        //1、非警情分流推送服务_宜宾市
        //   receive-工单受理
        //   http://10.12.185.168:8001/service/api/ds/110To12345/chainAlarm
        public string token1_token { get; set; }
        public string token1_dcsm { get; set; }
        public string token1_sm2_public { get; set; }
        public string token1_sm2_private { get; set; }
        public string token1_sm4 { get; set; }
        public string token1_sm4_mw { get; set; }

        //4、警务警情分流推送服务_宜宾市
        //   receive-工单办结
        //   http://10.12.185.168:8001/service/api/ds/110To12345/chainDeal
        public string token4_token { get; set; }
        public string token4_dcsm { get; set; }
        public string token4_sm2_public { get; set; }
        public string token4_sm2_private { get; set; }
        public string token4_sm4 { get; set; }
        public string token4_sm4_mw { get; set; }

        //3、警务警情分流查询服务_宜宾市
        //   send-工单受理
        //   http://10.12.185.168:8001/service/api/ds/12345To110/chainAlarm
        public string token3_token { get; set; }
        public string token3_dcsm { get; set; }
        public string token3_sm2_public { get; set; }
        public string token3_sm2_private { get; set; }
        public string token3_sm4 { get; set; }
        public string token3_sm4_mw { get; set; }

        //2、非警情分流查询服务_宜宾市
        //   send-工单办结
        //   http://10.12.185.168:8001/service/api/ds/12345To110/chainDeal
        public string token2_token { get; set; }
        public string token2_dcsm { get; set; }
        public string token2_sm2_public { get; set; }
        public string token2_sm2_private { get; set; }
        public string token2_sm4 { get; set; }
        public string token2_sm4_mw { get; set; }

        //5、从公安网侧获取12345政务服务热线平台知识库列表
        //   send-知识库列表
        //   http://10.12.185.168:8001/service/api/ds/get_knowledge_info
        public string token5_token { get; set; }
        public string token5_dcsm { get; set; }
        public string token5_sm2_public { get; set; }
        public string token5_sm2_private { get; set; }
        public string token5_sm4 { get; set; }
        public string token5_sm4_mw { get; set; }

        //6、从公安网侧获取12345政务服务热线平台知识内容
        //   send-知识库内容
        //   http://10.12.185.168:8001/service/api/ds/get_knowledge_content
        public string token6_token { get; set; }
        public string token6_dcsm { get; set; }
        public string token6_sm2_public { get; set; }
        public string token6_sm2_private { get; set; }
        public string token6_sm4 { get; set; }
        public string token6_sm4_mw { get; set; }
    }

    /// <summary>
    /// 大成均图110
    /// </summary>
    public class ConfigurationPoliceDCJT
    {
        /// <summary>
        /// 管辖单位代码
        /// </summary>
        public string GXDWDM { get; set; } = string.Empty;

        /// <summary>
        /// 管辖单位名称
        /// </summary>
        public string GXDWMC { get; set; } = string.Empty;

        /// <summary>
        /// 管辖单位电话
        /// </summary>
        public string GXDWDH { get; set; } = string.Empty;

        //1、非警情分流推送服务_XX市
        //   receive-工单受理
        public string token1_token { get; set; }
        public string token1_dcsm { get; set; }
        public string token1_sm2_public { get; set; }
        public string token1_sm2_private { get; set; }
        public string token1_sm4 { get; set; }
        public string token1_sm4_mw { get; set; }

        //4、警务警情分流推送服务_XX市
        //   receive-工单办结
        public string token4_token { get; set; }
        public string token4_dcsm { get; set; }
        public string token4_sm2_public { get; set; }
        public string token4_sm2_private { get; set; }
        public string token4_sm4 { get; set; }
        public string token4_sm4_mw { get; set; }

        //3、警务警情分流查询服务_XX市
        //   send-工单受理
        public string token3_token { get; set; }
        public string token3_dcsm { get; set; }
        public string token3_sm2_public { get; set; }
        public string token3_sm2_private { get; set; }
        public string token3_sm4 { get; set; }
        public string token3_sm4_mw { get; set; }

        //2、非警情分流查询服务_XX市
        //   send-工单办结
        public string token2_token { get; set; }
        public string token2_dcsm { get; set; }
        public string token2_sm2_public { get; set; }
        public string token2_sm2_private { get; set; }
        public string token2_sm4 { get; set; }
        public string token2_sm4_mw { get; set; }

        //5、从公安网侧获取12345政务服务热线平台知识库列表
        //   send-知识库列表
        public string token5_token { get; set; }
        public string token5_dcsm { get; set; }
        public string token5_sm2_public { get; set; }
        public string token5_sm2_private { get; set; }
        public string token5_sm4 { get; set; }
        public string token5_sm4_mw { get; set; }

        //6、从公安网侧获取12345政务服务热线平台知识内容
        //   send-知识库内容
        public string token6_token { get; set; }
        public string token6_dcsm { get; set; }
        public string token6_sm2_public { get; set; }
        public string token6_sm2_private { get; set; }
        public string token6_sm4 { get; set; }
        public string token6_sm4_mw { get; set; }
    }

    /// <summary>
    /// 海能达110
    /// </summary>
    public class ConfigurationPoliceHND
    {
        /// <summary>
        /// 管辖单位代码
        /// </summary>
        public string GXDWDM { get; set; } = string.Empty;

        /// <summary>
        /// 管辖单位名称
        /// </summary>
        public string GXDWMC { get; set; } = string.Empty;

        /// <summary>
        /// 管辖单位电话
        /// </summary>
        public string GXDWDH { get; set; } = string.Empty;

        //1、非警情分流推送服务_XX市
        //   receive-工单受理
        public string token1_token { get; set; }
        public string token1_dcsm { get; set; }
        public string token1_sm2_public { get; set; }
        public string token1_sm2_private { get; set; }
        public string token1_sm4 { get; set; }
        public string token1_sm4_mw { get; set; }

        //4、警务警情分流推送服务_XX市
        //   receive-工单办结
        public string token4_token { get; set; }
        public string token4_dcsm { get; set; }
        public string token4_sm2_public { get; set; }
        public string token4_sm2_private { get; set; }
        public string token4_sm4 { get; set; }
        public string token4_sm4_mw { get; set; }

        //3、警务警情分流查询服务_XX市
        //   send-工单受理
        public string token3_token { get; set; }
        public string token3_dcsm { get; set; }
        public string token3_sm2_public { get; set; }
        public string token3_sm2_private { get; set; }
        public string token3_sm4 { get; set; }
        public string token3_sm4_mw { get; set; }

        //2、非警情分流查询服务_XX市
        //   send-工单办结
        public string token2_token { get; set; }
        public string token2_dcsm { get; set; }
        public string token2_sm2_public { get; set; }
        public string token2_sm2_private { get; set; }
        public string token2_sm4 { get; set; }
        public string token2_sm4_mw { get; set; }

        //5、从公安网侧获取12345政务服务热线平台知识库列表
        //   send-知识库列表
        public string token5_token { get; set; }
        public string token5_dcsm { get; set; }
        public string token5_sm2_public { get; set; }
        public string token5_sm2_private { get; set; }
        public string token5_sm4 { get; set; }
        public string token5_sm4_mw { get; set; }

        //6、从公安网侧获取12345政务服务热线平台知识内容
        //   send-知识库内容
        public string token6_token { get; set; }
        public string token6_dcsm { get; set; }
        public string token6_sm2_public { get; set; }
        public string token6_sm2_private { get; set; }
        public string token6_sm4 { get; set; }
        public string token6_sm4_mw { get; set; }
    }

    /// <summary>
    /// 新老数据交换
    /// </summary>
    public class ConfigurationSendDataOld
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string AddressUrl { get; set; } = string.Empty;

        /// <summary>
        /// id
        /// </summary>
        public string ClientID { get; set; } = string.Empty;

        /// <summary>
        /// 密钥
        /// </summary>
        public string Secret { get; set; } = string.Empty;

        /// <summary>
        /// 
        /// </summary>
        public bool IsSend { get; set; }
    }

    /// <summary>
    /// 查询公开数据
    /// </summary>
    public class ConfigurationTFTB
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string QueryOldList { get; set; } = string.Empty;
    }

    /// <summary>
    /// 智慧城市系统
    /// </summary>
    public class ConfigurationSmartCitySystem
    {
        /// <summary>
        /// 是否开启推送
        /// </summary>
        public bool IsSendPush { get; set; }

        /// <summary>
        /// 请求的址
        /// </summary>
        public string AddressUrl { get; set; } = string.Empty;

        /// <summary>
        /// 请求接口
        /// </summary>
        public string PushDataUrl { get; set; } = string.Empty;
    }

    /// <summary>
    /// 写入工单数据
    /// </summary>
    public class ConfigurationHotlineClient
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string AddressUrl { get; set; } = string.Empty;

    }

    /// <summary>
    /// 应急管理局
    /// </summary>
    public class YingJiGuanLiJuConfiguration
    {
        public string DbConnectionString { get; set; }
    }

    /// <summary>
    /// 泸州110推送工单数据
    /// </summary>
    public class LuZhou110Configuration
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string SendDataAddress { get; set; } = string.Empty;
    }


    /// <summary>
    /// 泸州酒城一通
    /// </summary>
    public class LuZhouWineCityConfiguration
    {
        /// <summary>
        /// 请求的址
        /// </summary>
        public string SendDataAddress { get; set; } = string.Empty;
    }
}
