﻿using DataSharing.Share.Enums;
using SqlSugar;
using XF.Domain.Repository;

namespace DataSharing.Province.SendTask.ProvinceOther
{
    public class DsSendCall : CreationEntity
    {
        /// <summary>
        /// 数据读取状态 
        /// </summary>
        [SugarColumn(ColumnDescription = "数据读取状态")]
        public EWaitSendTaskState State { get; set; } = EWaitSendTaskState.WaitPush;

        /// <summary>
        /// 标识版本字段
        /// </summary>
        [SqlSugar.SugarColumn(IsEnableUpdateVersionValidation = true)]
        public Guid Ver { get; set; }

        /// <summary>
        /// 旧数据id
        /// </summary>
        public string OldDataId { get; set; }

        /// <summary>
        /// 组装参数
        /// </summary>
        [SugarColumn(ColumnDataType = "json", IsJson = true, IsNullable = true, ColumnDescription = "组装参数")]
        public Share.Dtos.Province.HuiJu.SubmitCaseRecordInfo RequestData { get; set; }

        /// <summary>
        /// 推送次数
        /// </summary>
        [SugarColumn(ColumnDescription = "推送次数")]
        public int SendTimes { get; set; }
    }
}
