﻿using DataSharing.SendTask;
using DataSharing.Share.Dtos;
using Hotline.Share.Dtos.File;
using SqlSugar;
using System.ComponentModel;
using System.Text.Json.Serialization;

namespace DataSharing.Province.SendTask.ProvinceOther
{
    /// <summary>
    /// 省平台其他业务待推送任务数据
    /// </summary>
    [Description("省平台其他业务待推送任务数据")]
    public class DsWaitSendTaskProvinceOther : BaseWaitSendTask
    {
        /// <summary>
        /// 组装参数
        /// </summary>
        [SugarColumn(ColumnDataType = "text", ColumnDescription = "组装参数")]
        public string RequestData { get; set; }

        /// <summary>
        /// 附件
        /// </summary>
        [SugarColumn(ColumnDataType = "json", IsJson = true, IsNullable = true)]
        public List<FileJson>? FileJson { get; set; }

        /// <summary>
        /// 回访结果满意度
        /// </summary>
        [SugarColumn(ColumnDescription = "回访结果满意度")]
        public string? SubjectResultSatify { get; set; }

        /// <summary>
        /// 回访时间
        /// </summary>
        [SugarColumn(ColumnDescription = "回访时间")]
        public DateTime? VisitTime { get; set; }
    }
}
