﻿using DataSharing.SendTask;
using SqlSugar;
using System.ComponentModel;

namespace DataSharing.Province.SendTask.SubmitCaseRecord
{
    /// <summary>
    /// 业务汇聚-电话记录推送任务数据
    /// </summary>
    [Description("业务汇聚-电话记录推送任务数据")]
    [SugarIndex("index_dssendtasksubmitcaserecord_callid", nameof(CallId), OrderByType.Desc)]
    [SugarIndex("index_dssendtasksubmitcaserecord_calllogid", nameof(CallLogId), OrderByType.Desc)]
    [SugarIndex("index_dssendtasksubmitcaserecord_provinceno", nameof(ProvinceNo), OrderByType.Desc)]
    [SugarIndex("index_dssendtasksubmitcaserecord_firsttime", nameof(FirstTime), OrderByType.Desc)]
    [SugarIndex("index_dssendtasksubmitcaserecord_lasttime", nameof(LastTime), OrderByType.Desc)]
    [SugarIndex("index_dssendtasksubmitcaserecord_generationtime", nameof(GenerationTime), OrderByType.Desc)]
    public class DsSendTaskSubmitCaseRecord : BaseSendTask
    {
        /// <summary>
        /// 组装参数
        /// </summary>
        [SugarColumn(ColumnDataType = "json", IsJson = true, IsNullable = true, ColumnDescription = "组装参数")]
        public Share.Dtos.Province.HuiJu.SubmitCaseRecordInfo RequestData { get; set; }

        /// <summary>
        /// 待推送数据
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(Id))]
        public DsWaitSendTaskSubmitCaseRecord WaitSendTaskSubmitCaseRecord { get; set; }

        /// <summary>
        /// 通话记录ID
        /// </summary>
        [SugarColumn(ColumnDescription = "通话记录ID", IsNullable = true)]
        public string? CallId { get; set; }

        /// <summary>
        /// 呼叫方向 0：呼入；1：呼出
        /// </summary>
        [SugarColumn(ColumnDescription = "呼叫方向", IsNullable = true)]
        public string? CallDirection { get; set; }

        /// <summary>
        /// 通话状态 1：接通；2：未接通
        /// </summary>
        [SugarColumn(ColumnDescription = "通话状态 1：接通；2：未接通", IsNullable = true)]
        public string? OnState { get; set; }

        /// <summary>
        /// 通话记录本地ID
        /// </summary>
        [SugarColumn(ColumnDescription = "通话记录本地ID", IsNullable = true)]
        public string? CallLogId { get; set; }
    }
}
