﻿using DataSharing.Share.Dtos.Province;
using SqlSugar;
using System.ComponentModel;
using XF.Domain.Repository;

namespace DataSharing.SendTask
{
    /// <summary>
    /// 推送任务数据明细
    /// </summary>
    [Description("推送任务数据明细")]
    public class DsSendTaskInfo : CreationEntity
    {
        /// <summary>
        /// 任务Id
        /// </summary>
        [SugarColumn(ColumnDescription = "任务Id")]
        public string TaskId { get; set; }

        /// <summary>
        /// 推送成功
        /// </summary>
        [SugarColumn(ColumnDescription = "推送成功")]
        public bool IsSuccess { get; set; }

        /// <summary>
        /// 返回数据
        /// </summary>
        [SugarColumn(ColumnDataType = "json", IsJson = true, IsNullable = true, ColumnDescription = "返回数据")]
        public ProvinceResponse? Result { get; set; }

        /// <summary>
        /// 其他平台返回数据
        /// </summary>
        [SugarColumn(ColumnDataType = "text", IsNullable = true, ColumnDescription = "其他平台返回数据")]
        public string? RequestInfo { get; set; }
    }
}
