﻿using DataSharing.Share.Dtos;
using DataSharing.Share.Enums;
using Hotline.Share.Dtos.File;
using SqlSugar;
using System.ComponentModel;

namespace DataSharing.SendTask.OtherPlatforms
{
    /// <summary>
    /// 其他平台推送任务数据
    /// </summary>
    [Description("其他平台推送任务数据")]
    public class DsSendTaskOtherPlatforms : BaseSendTask
    {
        /// <summary>
        /// 平台名称
        /// </summary>
        [SugarColumn(ColumnDescription = "平台名称")]
        public EPlatformSource PlatformSource { get; set; } = EPlatformSource.Province;

        /// <summary>
        /// 组装参数
        /// </summary>
        [SugarColumn(ColumnDataType = "text", ColumnDescription = "组装参数")]
        public string RequestData { get; set; }

        /// <summary>
        /// 附件
        /// </summary>
        [SugarColumn(ColumnDataType = "json", IsJson = true, IsNullable = true)]
        public List<FileJson>? FileJson { get; set; }

        /// <summary>
        /// 待推送数据
        /// </summary>
        [Navigate(NavigateType.OneToOne, nameof(Id))]
        public DsWaitSendTaskOtherPlatforms WaitSendTaskOtherPlatforms { get; set; }
    }
}
